
## Chapter 5, Ex. 5.5

### process .csv (from Yahoo Finance) to .RData
rm(list=ls())
	#setwd("C:/Course/ORF504 Financial Econometrics/Spring 2011/Projects/4.5")  
  RawData = read.csv("RawData.csv")
	#save(RawData, file="4_5.RData")

### Testing CAPM: Lintner version
  #rm(list=ls())
  #setwd("C:/Course/ORF504 Financial Econometrics/Spring 2011/Projects/4.5")
  #load("4_5.RData")     # RawData
  
  attach(RawData) 
  RFrate180 = rev( 100 * ( ( 1+ IRX/100)^(1/12) - 1 ) )[2:181]
  SPXexr180 = 100*diff(log(rev(SPX)))[1:180]   - RFrate180 
  detach(RawData)


  #  monthly excess log returns.
  RawData120 = RawData[1:121,]
  attach(RawData120)
  RFrate = rev( 100 * ( ( 1+ IRX[-1] / 100  )^(1/12) - 1 ) )
  XOMexr = diff(log(rev(XOM))) * 100 - RFrate 
  GEexr =  diff(log(rev(GE))) * 100  - RFrate 
  JNJexr = diff(log(rev(JNJ))) * 100 - RFrate  
  SPXexr = diff(log(rev(SPX)))* 100   - RFrate 
  
  
  ls.print( lsfit(SPXexr,  XOMexr) )   # Exxon Mobile
  ls.print( lsfit(SPXexr,  GEexr) )   #  GE
  ls.print( lsfit(SPXexr,  JNJexr) )   #  JNJ
  
  
  
  RFrate180 = rev( 100 * ( ( 1+ IRX/100)^(1/12) - 1 ) )
  SPXexr180 = diff(log(rev(SPX)))* 100   - RFrate180 

  mean(SPXexr180)  ##  0.1411328
  mean(RFrate180)  ##   0.2500645
  mean(SPXexr180 + RFrate180)  ##   0.3911973
  
  print( mean(RFrate180) + 0.5416 * mean(SPXexr180)  )   # Exxon
  print( mean(RFrate180)+  1.3861 * mean(SPXexr180)  )   # GE
  print( mean(RFrate180) + 0.4926 * mean(SPXexr180)  )   # JNJ
  
  ##         XOM        GE         JNJ
  ## alpha   0.6848    -0.4155    0.2588
  ## P-v     0.1076     0.4445    0.4585
  ## beta    0.5416     1.3848    0.4927
  ## Exp_Ret 0.3265     0.4457    0.3196
  
  Y <-  data.frame( cbind(XOMexr, GEexr, JNJexr) )
  residuals <- resid( lsfit(SPXexr, Y))
  Sigma <- t(residuals) %*% residuals / 120
  alpha <- c(0.6862, -0.4166, 0.2604)
  mreturn <- mean( SPXexr )  
  msigma <- var( SPXexr )
  T0 <- 120/( 1+mreturn^2/msigma ) * t(alpha) %*% solve(Sigma, alpha)
  T0  ## 3.901379
  1 - pchisq(T0, 3)     ## p-value for T0      0.2723122
  T1 <- (120-3-1)/3/120*T0
  T1  ## 1.257111    
  1 - pf(T1, 3, 120-3-1) ## p-value for T1     0.2924657
  
  T3 <- (120-3/2-2)*log( 1+ 3*T1/(120-3-1))
  T3 ## 3.727321
  1 - pchisq(T3, 3)  ## p-value for T3         0.2924538
  
  
## Black Version
  #rm(list=ls())
  #setwd("C:/Course/ORF504 Financial Econometrics/Spring 2011/Projects/4.5")  
  #load("4_5.RData")  
  #RawData120 = RawData[1:121,]
  #attach(RawData120)
  XOMr = diff(log(rev(XOM))) * 100  
  GEr =  diff(log(rev(GE))) * 100  
  JNJr = diff(log(rev(JNJ))) * 100 
  SPXr = diff(log(rev(SPX)))* 100   
  
  
  ## step 1: unrestricted MLE
  Y <-  data.frame( cbind(XOMr, GEr, JNJr) )
  Fit <-  lsfit(SPXr, Y)
  betaH <- Fit$coef[2,]
  betaH
  residuals <- resid( Fit)
  SigmaH  <- t(residuals) %*% residuals / 120
  SigmaH
        ###           Y1        Y2         Y3
        ###   Y1 21.0870359 -2.699429 -0.8435741
        ###   Y2 -2.6994291 34.573332  2.6560063
        ###   Y3 -0.8435741  2.656006 14.3008704
  
  ## step 2: \hat \gamma_0
  GammaH0_num <- t(1- betaH ) %*% solve( SigmaH ) %*%
  (mean(Y) - mean(SPXr)*betaH)
  GammaH0_den <- t(1 - betaH) %*% solve(SigmaH) %*% (1-betaH)
  GammaH0 <-  GammaH0_num / GammaH0_den
  GammaH0   ##  
  
  ## step3::  \hat \beta_0, \hat \Sigma_0
  SigmaH0 <- SigmaH
  betaH0 <- betaH
  
  betaH0 <- lsfit(SPXr-GammaH0, data.frame(Y- GammaH0), intercept=F )$coef
  betaH0  <- t(as.matrix(betaH0))
  betaH0 ##
  
  
  resid0 <- Y -  rep(GammaH0,120)%*%t(1-betaH0) - SPXr%*%t(betaH0)
  resid0 <- as.matrix(resid0)
  SigmaH0 <-    t(resid0) %*% resid0 / 120
  SigmaH0  ## from Step 3
  
  ## step4: 2 iterations
     # first iteration
  GammaH0_num <- t(1- betaH0 ) %*% solve( SigmaH0 ) %*%
  (mean(Y) - mean(SPXr)*betaH0)
  GammaH0_den <- t(1 - betaH0) %*% solve(SigmaH0) %*% (1-betaH0)
  GammaH0 <-  GammaH0_num / GammaH0_den
  GammaH0   ##  
  
  betaH0 <- lsfit(SPXr-GammaH0, data.frame(Y- GammaH0), intercept=F )$coef
  betaH0  <- t(as.matrix(betaH0))
  betaH0 ##
  
  
  resid0 <- Y -  rep(GammaH0,120)%*%t(1-betaH0) - SPXr%*%t(betaH0)
  resid0 <- as.matrix(resid0)
  SigmaH0 <-    t(resid0) %*% resid0 / 120
  SigmaH0  ## 1st
      ###          XOMr       GEr       JNJr
      ###XOMr 21.1639440 -2.719744 -0.8943376
      ###GEr  -2.7197440 34.578698  2.6694152
      ###JNJr -0.8943376  2.669415 14.3343770

  
 
       # second  iteration
  GammaH0_num <- t(1- betaH0 ) %*% solve( SigmaH0 ) %*%
  (mean(Y) - mean(SPXr)*betaH0)
  GammaH0_den <- t(1 - betaH0) %*% solve(SigmaH0) %*% (1-betaH0)
  GammaH0 <-  GammaH0_num / GammaH0_den
  GammaH0   ##   1.048564
  
  betaH0 <- lsfit(SPXr-GammaH0, data.frame(Y- GammaH0), intercept=F )$coef
  betaH0  <- t(as.matrix(betaH0))
  betaH0 ##        
  
  resid0 <- Y -  rep(GammaH0,120)%*%t(1-betaH0) - SPXr%*%t(betaH0)
  resid0 <- as.matrix(resid0)
  SigmaH0 <-    t(resid0) %*% resid0 / 120
  SigmaH0  ## 2nd
      ###      XOMr       GEr       JNJr
      ###XOMr 21.1638499 -2.719692 -0.8943566
      ###GEr  -2.7196924 34.578677  2.6694026
      ###JNJr -0.8943566  2.669403 14.3344432
  
  
  ## step 5, 6
  T5 <- ( 120 - 3/2 - 2 ) * ( log(det(SigmaH0)) - log(det(SigmaH)) )
  T5      ## 0.66461
  1 - pchisq(T5,2)   ## 0.7172685


  ## some comments: \hat \Sigma_0 converges really fast after a couple of steps.
  ## \hat \gamma_0 ~ 1%, larger than actual risk free rate avg ~ 0.17%
  ## p-value is pretty large, suggesting CAPM holds. Consistent with Lintner.
  
  
  rm(list=ls())
  RawData = read.csv("RawData.csv")
  
  
  
  
  
  

  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  

